// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from foxglove_msgs:msg/CylinderMarker.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "foxglove_msgs/msg/cylinder_marker.h"


#ifndef FOXGLOVE_MSGS__MSG__DETAIL__CYLINDER_MARKER__FUNCTIONS_H_
#define FOXGLOVE_MSGS__MSG__DETAIL__CYLINDER_MARKER__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "foxglove_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "foxglove_msgs/msg/detail/cylinder_marker__struct.h"

/// Initialize msg/CylinderMarker message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * foxglove_msgs__msg__CylinderMarker
 * )) before or use
 * foxglove_msgs__msg__CylinderMarker__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
bool
foxglove_msgs__msg__CylinderMarker__init(foxglove_msgs__msg__CylinderMarker * msg);

/// Finalize msg/CylinderMarker message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
void
foxglove_msgs__msg__CylinderMarker__fini(foxglove_msgs__msg__CylinderMarker * msg);

/// Create msg/CylinderMarker message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * foxglove_msgs__msg__CylinderMarker__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
foxglove_msgs__msg__CylinderMarker *
foxglove_msgs__msg__CylinderMarker__create(void);

/// Destroy msg/CylinderMarker message.
/**
 * It calls
 * foxglove_msgs__msg__CylinderMarker__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
void
foxglove_msgs__msg__CylinderMarker__destroy(foxglove_msgs__msg__CylinderMarker * msg);

/// Check for msg/CylinderMarker message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
bool
foxglove_msgs__msg__CylinderMarker__are_equal(const foxglove_msgs__msg__CylinderMarker * lhs, const foxglove_msgs__msg__CylinderMarker * rhs);

/// Copy a msg/CylinderMarker message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
bool
foxglove_msgs__msg__CylinderMarker__copy(
  const foxglove_msgs__msg__CylinderMarker * input,
  foxglove_msgs__msg__CylinderMarker * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
const rosidl_type_hash_t *
foxglove_msgs__msg__CylinderMarker__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
const rosidl_runtime_c__type_description__TypeDescription *
foxglove_msgs__msg__CylinderMarker__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
const rosidl_runtime_c__type_description__TypeSource *
foxglove_msgs__msg__CylinderMarker__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
foxglove_msgs__msg__CylinderMarker__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/CylinderMarker messages.
/**
 * It allocates the memory for the number of elements and calls
 * foxglove_msgs__msg__CylinderMarker__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
bool
foxglove_msgs__msg__CylinderMarker__Sequence__init(foxglove_msgs__msg__CylinderMarker__Sequence * array, size_t size);

/// Finalize array of msg/CylinderMarker messages.
/**
 * It calls
 * foxglove_msgs__msg__CylinderMarker__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
void
foxglove_msgs__msg__CylinderMarker__Sequence__fini(foxglove_msgs__msg__CylinderMarker__Sequence * array);

/// Create array of msg/CylinderMarker messages.
/**
 * It allocates the memory for the array and calls
 * foxglove_msgs__msg__CylinderMarker__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
foxglove_msgs__msg__CylinderMarker__Sequence *
foxglove_msgs__msg__CylinderMarker__Sequence__create(size_t size);

/// Destroy array of msg/CylinderMarker messages.
/**
 * It calls
 * foxglove_msgs__msg__CylinderMarker__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
void
foxglove_msgs__msg__CylinderMarker__Sequence__destroy(foxglove_msgs__msg__CylinderMarker__Sequence * array);

/// Check for msg/CylinderMarker message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
bool
foxglove_msgs__msg__CylinderMarker__Sequence__are_equal(const foxglove_msgs__msg__CylinderMarker__Sequence * lhs, const foxglove_msgs__msg__CylinderMarker__Sequence * rhs);

/// Copy an array of msg/CylinderMarker messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
bool
foxglove_msgs__msg__CylinderMarker__Sequence__copy(
  const foxglove_msgs__msg__CylinderMarker__Sequence * input,
  foxglove_msgs__msg__CylinderMarker__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // FOXGLOVE_MSGS__MSG__DETAIL__CYLINDER_MARKER__FUNCTIONS_H_
