// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from foxglove_msgs:msg/CompressedVideo.idl
// generated code does not contain a copyright notice

#include "foxglove_msgs/msg/detail/compressed_video__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
const rosidl_type_hash_t *
foxglove_msgs__msg__CompressedVideo__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x32, 0x03, 0x9e, 0xaf, 0xc3, 0x77, 0x0e, 0x58,
      0x9c, 0x86, 0xc4, 0xda, 0xbf, 0xf9, 0xc3, 0x92,
      0xce, 0x99, 0x55, 0xeb, 0xff, 0xd4, 0x3f, 0x5f,
      0x60, 0x76, 0x30, 0x11, 0xd4, 0x3d, 0x8d, 0x1d,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "builtin_interfaces/msg/detail/time__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t builtin_interfaces__msg__Time__EXPECTED_HASH = {1, {
    0xb1, 0x06, 0x23, 0x5e, 0x25, 0xa4, 0xc5, 0xed,
    0x35, 0x09, 0x8a, 0xa0, 0xa6, 0x1a, 0x3e, 0xe9,
    0xc9, 0xb1, 0x8d, 0x19, 0x7f, 0x39, 0x8b, 0x0e,
    0x42, 0x06, 0xce, 0xa9, 0xac, 0xf9, 0xc1, 0x97,
  }};
#endif

static char foxglove_msgs__msg__CompressedVideo__TYPE_NAME[] = "foxglove_msgs/msg/CompressedVideo";
static char builtin_interfaces__msg__Time__TYPE_NAME[] = "builtin_interfaces/msg/Time";

// Define type names, field names, and default values
static char foxglove_msgs__msg__CompressedVideo__FIELD_NAME__timestamp[] = "timestamp";
static char foxglove_msgs__msg__CompressedVideo__FIELD_NAME__frame_id[] = "frame_id";
static char foxglove_msgs__msg__CompressedVideo__FIELD_NAME__data[] = "data";
static char foxglove_msgs__msg__CompressedVideo__FIELD_NAME__format[] = "format";

static rosidl_runtime_c__type_description__Field foxglove_msgs__msg__CompressedVideo__FIELDS[] = {
  {
    {foxglove_msgs__msg__CompressedVideo__FIELD_NAME__timestamp, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE,
      0,
      0,
      {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    },
    {NULL, 0, 0},
  },
  {
    {foxglove_msgs__msg__CompressedVideo__FIELD_NAME__frame_id, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {foxglove_msgs__msg__CompressedVideo__FIELD_NAME__data, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {foxglove_msgs__msg__CompressedVideo__FIELD_NAME__format, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription foxglove_msgs__msg__CompressedVideo__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {builtin_interfaces__msg__Time__TYPE_NAME, 27, 27},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
foxglove_msgs__msg__CompressedVideo__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {foxglove_msgs__msg__CompressedVideo__TYPE_NAME, 33, 33},
      {foxglove_msgs__msg__CompressedVideo__FIELDS, 4, 4},
    },
    {foxglove_msgs__msg__CompressedVideo__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&builtin_interfaces__msg__Time__EXPECTED_HASH, builtin_interfaces__msg__Time__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = builtin_interfaces__msg__Time__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# foxglove_msgs/msg/CompressedVideo\n"
  "# A single frame of a compressed video bitstream\n"
  "\n"
  "# Generated by https://github.com/foxglove/schemas\n"
  "\n"
  "# Timestamp of video frame\n"
  "builtin_interfaces/Time timestamp\n"
  "\n"
  "# Frame of reference for the video.\n"
  "# \n"
  "# The origin of the frame is the optical center of the camera. +x points to the right in the video, +y points down, and +z points into the plane of the video.\n"
  "string frame_id\n"
  "\n"
  "# Compressed video frame data.\n"
  "# \n"
  "# For packet-based video codecs this data must begin and end on packet boundaries (no partial packets), and must contain enough video packets to decode exactly one image (either a keyframe or delta frame). Note: Foxglove Studio does not support video streams that include B frames because they require lookahead.\n"
  "uint8[] data\n"
  "\n"
  "# Video format.\n"
  "# \n"
  "# Supported values: `h264` (Annex B formatted data only)\n"
  "string format";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
foxglove_msgs__msg__CompressedVideo__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {foxglove_msgs__msg__CompressedVideo__TYPE_NAME, 33, 33},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 866, 866},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
foxglove_msgs__msg__CompressedVideo__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *foxglove_msgs__msg__CompressedVideo__get_individual_type_description_source(NULL),
    sources[1] = *builtin_interfaces__msg__Time__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
